import Vue from 'vue'
import imagePreview from './index.vue'

let newInstance = null

// 将vue组件变为构造函数
const ConfirmConstructor = Vue.extend(imagePreview)

const init = (options) => {
  // 实例化组件
  newInstance = new ConfirmConstructor()
  // 合并配置选项
  Object.assign(newInstance, options)
  // 使用$mount()后  可以理解为创建虚拟的dom
  document.body.appendChild(newInstance.$mount().$el)
}
const caller = (options) => {
  // options 为调用组件方法时传入的配置选项
  if (!newInstance) {
    init(options)
  }
  // 每次接受指令时 更新赋值参数
  Object.assign(newInstance, options)
  return newInstance.startPreView(vm => { newInstance = null })
}
export default {
  install(vue) {
    vue.prototype.$preview = caller
  }
}
